import * as i0 from '@angular/core';
import { Component, NgModule } from '@angular/core';
import * as i2 from '@angular/forms';
import { ReactiveFormsModule } from '@angular/forms';
import { BsDynamicFormInputWrapperComponent, bsDynamicFormLibrary } from '@dynamic-forms/bootstrap';
import { DynamicFormInputMaskBase, DynamicFormInputMaskDirective, DynamicFormInputMaskControl } from '@dynamic-forms/core/input-mask';
import * as i1 from '@dynamic-forms/core';
import { withDynamicFormInputs, importDynamicFormsProviders } from '@dynamic-forms/core';

class BsDynamicFormInputMaskComponent extends DynamicFormInputMaskBase {
    constructor(validationService) {
        super(validationService);
        this.validationService = validationService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormInputMaskComponent, deps: [{ token: i1.DynamicFormValidationService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.0.1", type: BsDynamicFormInputMaskComponent, isStandalone: true, selector: "bs-dynamic-form-input-mask", usesInheritance: true, ngImport: i0, template: "<bs-dynamic-form-input-wrapper\n  [inputTemplate]=\"inputTemplate\"\n  [inputId]=\"inputId\"\n  [label]=\"template.label\"\n  [labelFloating]=\"template.labelFloating\"\n  [requiredMarker]=\"validation?.required\"\n  [prefixAddOn]=\"prefixAddOn\"\n  [suffixAddOn]=\"suffixAddOn\"\n/>\n\n<ng-template #inputTemplate>\n  <input\n    class=\"form-control\"\n    [id]=\"inputId\"\n    [dynamicFormInputMask]=\"inputMask\"\n    [placeholder]=\"input.placeholder || ''\"\n    [readonly]=\"readonly\"\n    [required]=\"validation?.required\"\n    [formControl]=\"control\"\n  />\n</ng-template>\n", dependencies: [{ kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.RequiredValidator, selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { kind: "directive", type: i2.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "directive", type: DynamicFormInputMaskDirective, selector: "[dynamicFormInputMask]", inputs: ["dynamicFormInputMask"], exportAs: ["dynamicFormInputMask"] }, { kind: "component", type: BsDynamicFormInputWrapperComponent, selector: "bs-dynamic-form-input-wrapper", inputs: ["inputTemplate", "inputId", "label", "labelFloating", "requiredMarker", "inputAddOn", "prefixAddOn", "suffixAddOn"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormInputMaskComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'bs-dynamic-form-input-mask', imports: [ReactiveFormsModule, DynamicFormInputMaskDirective, BsDynamicFormInputWrapperComponent], template: "<bs-dynamic-form-input-wrapper\n  [inputTemplate]=\"inputTemplate\"\n  [inputId]=\"inputId\"\n  [label]=\"template.label\"\n  [labelFloating]=\"template.labelFloating\"\n  [requiredMarker]=\"validation?.required\"\n  [prefixAddOn]=\"prefixAddOn\"\n  [suffixAddOn]=\"suffixAddOn\"\n/>\n\n<ng-template #inputTemplate>\n  <input\n    class=\"form-control\"\n    [id]=\"inputId\"\n    [dynamicFormInputMask]=\"inputMask\"\n    [placeholder]=\"input.placeholder || ''\"\n    [readonly]=\"readonly\"\n    [required]=\"validation?.required\"\n    [formControl]=\"control\"\n  />\n</ng-template>\n" }]
        }], ctorParameters: () => [{ type: i1.DynamicFormValidationService }] });

const bsDynamicFormInputMaskType = {
    type: 'input-mask',
    component: BsDynamicFormInputMaskComponent,
    control: DynamicFormInputMaskControl,
    libraryName: bsDynamicFormLibrary.name,
};
function withBsDynamicFormInputMask() {
    return withDynamicFormInputs(bsDynamicFormInputMaskType);
}
/**
 * @deprecated Use {@link withBsDynamicFormInputMask} instead.
 */
class BsDynamicFormInputMaskModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormInputMaskModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormInputMaskModule }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormInputMaskModule, providers: importDynamicFormsProviders(withBsDynamicFormInputMask()) }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormInputMaskModule, decorators: [{
            type: NgModule,
            args: [{ providers: importDynamicFormsProviders(withBsDynamicFormInputMask()) }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { BsDynamicFormInputMaskComponent, BsDynamicFormInputMaskModule, bsDynamicFormInputMaskType, withBsDynamicFormInputMask };
//# sourceMappingURL=dynamic-forms-bootstrap-input-mask.mjs.map
