import * as i0 from '@angular/core';
import { Component, Input, NgModule } from '@angular/core';
import * as i1 from '@dynamic-forms/core';
import { DynamicFormElementsComponent, DynamicFormButtonBase, DynamicFormColorPipe, DynamicFormIconBase, DynamicFormIconPipe, withDynamicFormActions, importDynamicFormsProviders, DynamicFormAccordionBase, dynamicFormItemsFactory, withDynamicFormElements, DynamicFormTabsBase, DynamicFormModalBase, DynamicFormElementComponent, dynamicFormModalFactory, DynamicFormConfigModule, DynamicFormModalModule, withDynamicFormModalActionHandlers, DynamicFormControlWrapperBase, withDynamicFormFieldWrappers, DynamicFormInputBase, DynamicFormFileBase, DynamicFormFileDirective, withDynamicFormInputs, withDynamicFormTextboxActionHandlers, withDynamicFormFileValidators, withDynamicFormNativeDateConverter, withDynamicFormDatepickerValidators, DynamicFormFileModule, DynamicFormTextboxModule, provideDynamicForms, withDynamicFormValidation, withDynamicFormsTheme, withDynamicFormsIdBuilder, provideDynamicFormsWithDefaultFeatures, withDynamicFormsLibrary, DynamicFormsModule } from '@dynamic-forms/core';
import { AsyncPipe, NgClass, NgIf, NgStyle, NgFor, NgTemplateOutlet } from '@angular/common';
import * as i2 from '@angular/forms';
import { ReactiveFormsModule } from '@angular/forms';

const bsDynamicFormLibrary = {
    name: 'bootstrap',
    references: ['core'],
};

class BsDynamicFormDialogComponent {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormDialogComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.0.1", type: BsDynamicFormDialogComponent, isStandalone: true, selector: "bs-dynamic-form-dialog", inputs: { isOpen$: "isOpen$", children: "children", headerActions: "headerActions", footerActions: "footerActions", width: "width", height: "height", minWidth: "minWidth", minHeight: "minHeight", maxWidth: "maxWidth", maxHeight: "maxHeight", maximized: "maximized", title: "title", titleHtml: "titleHtml", classNameForm: "classNameForm", classNameModal: "classNameModal", classNameChildren: "classNameChildren", classNameHeader: "classNameHeader", classNameFooter: "classNameFooter", classNameTitle: "classNameTitle" }, ngImport: i0, template: "<!-- eslint-disable @angular-eslint/template/no-inline-styles -->\n<div *ngIf=\"isOpen$ | async\" class=\"dynamic-form-modal modal\" [ngClass]=\"classNameForm\" [class.maximized]=\"maximized\">\n  <div\n    class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable\"\n    [ngClass]=\"classNameModal\"\n    [class.maximized]=\"maximized\"\n    [ngStyle]=\"{\n      width: maximized ? maxWidth || '100%' : width,\n      'min-width': maximized ? maxWidth || '100%' : minWidth,\n      'max-width': maximized ? maxWidth || '100%' : maxWidth,\n      'min-height': maximized ? '100%' : undefined,\n      'max-height': maximized ? '100%' : undefined,\n      margin: maximized ? '0px auto' : undefined\n    }\"\n  >\n    <div\n      class=\"modal-content\"\n      [ngStyle]=\"{\n        height: maximized ? maxHeight || '100%' : height,\n        'min-height': maximized ? maxHeight || '100%' : minHeight,\n        'max-height': maxHeight || '100%'\n      }\"\n    >\n      <div *ngIf=\"title || titleHtml || headerActions?.length\" class=\"modal-header\" [ngClass]=\"classNameHeader\">\n        <div *ngIf=\"titleHtml; else titlePlain\" class=\"modal-title\" [ngClass]=\"classNameTitle\" [innerHTML]=\"titleHtml\"></div>\n        <ng-template #titlePlain>\n          <div class=\"modal-title\" [ngClass]=\"classNameTitle\">{{ title }}</div>\n        </ng-template>\n        <div *ngIf=\"headerActions?.length\" class=\"modal-toolbar\">\n          <dynamic-form-elements [elements]=\"headerActions\" />\n        </div>\n      </div>\n      <div class=\"modal-body\" [ngClass]=\"classNameChildren\">\n        <dynamic-form-elements [elements]=\"children\" />\n      </div>\n      <div *ngIf=\"footerActions?.length\" class=\"modal-footer\" [ngClass]=\"classNameFooter\">\n        <dynamic-form-elements [elements]=\"footerActions\" />\n      </div>\n    </div>\n  </div>\n</div>\n", dependencies: [{ kind: "pipe", type: AsyncPipe, name: "async" }, { kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "component", type: DynamicFormElementsComponent, selector: "dynamic-form-elements", inputs: ["elements"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormDialogComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'bs-dynamic-form-dialog', imports: [AsyncPipe, NgClass, NgIf, NgStyle, DynamicFormElementsComponent], template: "<!-- eslint-disable @angular-eslint/template/no-inline-styles -->\n<div *ngIf=\"isOpen$ | async\" class=\"dynamic-form-modal modal\" [ngClass]=\"classNameForm\" [class.maximized]=\"maximized\">\n  <div\n    class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable\"\n    [ngClass]=\"classNameModal\"\n    [class.maximized]=\"maximized\"\n    [ngStyle]=\"{\n      width: maximized ? maxWidth || '100%' : width,\n      'min-width': maximized ? maxWidth || '100%' : minWidth,\n      'max-width': maximized ? maxWidth || '100%' : maxWidth,\n      'min-height': maximized ? '100%' : undefined,\n      'max-height': maximized ? '100%' : undefined,\n      margin: maximized ? '0px auto' : undefined\n    }\"\n  >\n    <div\n      class=\"modal-content\"\n      [ngStyle]=\"{\n        height: maximized ? maxHeight || '100%' : height,\n        'min-height': maximized ? maxHeight || '100%' : minHeight,\n        'max-height': maxHeight || '100%'\n      }\"\n    >\n      <div *ngIf=\"title || titleHtml || headerActions?.length\" class=\"modal-header\" [ngClass]=\"classNameHeader\">\n        <div *ngIf=\"titleHtml; else titlePlain\" class=\"modal-title\" [ngClass]=\"classNameTitle\" [innerHTML]=\"titleHtml\"></div>\n        <ng-template #titlePlain>\n          <div class=\"modal-title\" [ngClass]=\"classNameTitle\">{{ title }}</div>\n        </ng-template>\n        <div *ngIf=\"headerActions?.length\" class=\"modal-toolbar\">\n          <dynamic-form-elements [elements]=\"headerActions\" />\n        </div>\n      </div>\n      <div class=\"modal-body\" [ngClass]=\"classNameChildren\">\n        <dynamic-form-elements [elements]=\"children\" />\n      </div>\n      <div *ngIf=\"footerActions?.length\" class=\"modal-footer\" [ngClass]=\"classNameFooter\">\n        <dynamic-form-elements [elements]=\"footerActions\" />\n      </div>\n    </div>\n  </div>\n</div>\n" }]
        }], propDecorators: { isOpen$: [{
                type: Input
            }], children: [{
                type: Input
            }], headerActions: [{
                type: Input
            }], footerActions: [{
                type: Input
            }], width: [{
                type: Input
            }], height: [{
                type: Input
            }], minWidth: [{
                type: Input
            }], minHeight: [{
                type: Input
            }], maxWidth: [{
                type: Input
            }], maxHeight: [{
                type: Input
            }], maximized: [{
                type: Input
            }], title: [{
                type: Input
            }], titleHtml: [{
                type: Input
            }], classNameForm: [{
                type: Input
            }], classNameModal: [{
                type: Input
            }], classNameChildren: [{
                type: Input
            }], classNameHeader: [{
                type: Input
            }], classNameFooter: [{
                type: Input
            }], classNameTitle: [{
                type: Input
            }] } });

class BsDynamicFormButtonComponent extends DynamicFormButtonBase {
    constructor(actionService) {
        super(actionService);
        this.actionService = actionService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormButtonComponent, deps: [{ token: i1.DynamicFormActionService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.0.1", type: BsDynamicFormButtonComponent, isStandalone: true, selector: "bs-dynamic-form-button", usesInheritance: true, ngImport: i0, template: "<a\n  *ngIf=\"template.url; else button\"\n  [class]=\"'dynamic-form-button btn btn-' + (template.color | dynamicFormColor: 'primary')\"\n  [class.disabled]=\"template.disabled\"\n  [ngClass]=\"template.className\"\n  [hidden]=\"template.hidden\"\n  [href]=\"template.url\"\n  [target]=\"template.urlTarget || '_blank'\"\n  >{{ template.label }}</a\n>\n\n<ng-template #button>\n  <button\n    [id]=\"id\"\n    [class]=\"'dynamic-form-button btn btn-' + (template.color | dynamicFormColor: 'primary')\"\n    [ngClass]=\"template.className\"\n    [type]=\"template.type || 'button'\"\n    [disabled]=\"template.disabled\"\n    [hidden]=\"template.hidden\"\n    (click)=\"onClick($event)\"\n    >{{ template.label }}</button\n  >\n</ng-template>\n\n<bs-dynamic-form-dialog\n  *ngIf=\"dialog\"\n  [isOpen$]=\"dialogOpen$\"\n  [children]=\"dialogChildren\"\n  [headerActions]=\"dialogHeaderActions\"\n  [footerActions]=\"dialogFooterActions\"\n  [width]=\"template.dialogWidth\"\n  [minWidth]=\"template.dialogMinWidth\"\n  [maxWidth]=\"template.dialogMaxWidth\"\n  [title]=\"template.dialogTitle\"\n  [titleHtml]=\"template.dialogTitleHtml\"\n  [classNameForm]=\"element.root.template.className\"\n  [classNameModal]=\"template.className\"\n  [classNameTitle]=\"template.classNameDialogTitle\"\n  [classNameChildren]=\"dialogTemplate?.classNameChildren\"\n  [classNameHeader]=\"dialogTemplate?.classNameHeader\"\n  [classNameFooter]=\"dialogTemplate?.classNameFooter\"\n/>\n", dependencies: [{ kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "pipe", type: DynamicFormColorPipe, name: "dynamicFormColor" }, { kind: "component", type: BsDynamicFormDialogComponent, selector: "bs-dynamic-form-dialog", inputs: ["isOpen$", "children", "headerActions", "footerActions", "width", "height", "minWidth", "minHeight", "maxWidth", "maxHeight", "maximized", "title", "titleHtml", "classNameForm", "classNameModal", "classNameChildren", "classNameHeader", "classNameFooter", "classNameTitle"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormButtonComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'bs-dynamic-form-button', imports: [NgClass, NgIf, DynamicFormColorPipe, BsDynamicFormDialogComponent], template: "<a\n  *ngIf=\"template.url; else button\"\n  [class]=\"'dynamic-form-button btn btn-' + (template.color | dynamicFormColor: 'primary')\"\n  [class.disabled]=\"template.disabled\"\n  [ngClass]=\"template.className\"\n  [hidden]=\"template.hidden\"\n  [href]=\"template.url\"\n  [target]=\"template.urlTarget || '_blank'\"\n  >{{ template.label }}</a\n>\n\n<ng-template #button>\n  <button\n    [id]=\"id\"\n    [class]=\"'dynamic-form-button btn btn-' + (template.color | dynamicFormColor: 'primary')\"\n    [ngClass]=\"template.className\"\n    [type]=\"template.type || 'button'\"\n    [disabled]=\"template.disabled\"\n    [hidden]=\"template.hidden\"\n    (click)=\"onClick($event)\"\n    >{{ template.label }}</button\n  >\n</ng-template>\n\n<bs-dynamic-form-dialog\n  *ngIf=\"dialog\"\n  [isOpen$]=\"dialogOpen$\"\n  [children]=\"dialogChildren\"\n  [headerActions]=\"dialogHeaderActions\"\n  [footerActions]=\"dialogFooterActions\"\n  [width]=\"template.dialogWidth\"\n  [minWidth]=\"template.dialogMinWidth\"\n  [maxWidth]=\"template.dialogMaxWidth\"\n  [title]=\"template.dialogTitle\"\n  [titleHtml]=\"template.dialogTitleHtml\"\n  [classNameForm]=\"element.root.template.className\"\n  [classNameModal]=\"template.className\"\n  [classNameTitle]=\"template.classNameDialogTitle\"\n  [classNameChildren]=\"dialogTemplate?.classNameChildren\"\n  [classNameHeader]=\"dialogTemplate?.classNameHeader\"\n  [classNameFooter]=\"dialogTemplate?.classNameFooter\"\n/>\n" }]
        }], ctorParameters: () => [{ type: i1.DynamicFormActionService }] });

const bsDynamicFormButtonType = {
    type: 'button',
    component: BsDynamicFormButtonComponent,
    libraryName: bsDynamicFormLibrary.name,
};

class BsDynamicFormIconComponent extends DynamicFormIconBase {
    constructor(actionService) {
        super(actionService);
        this.actionService = actionService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormIconComponent, deps: [{ token: i1.DynamicFormActionService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.0.1", type: BsDynamicFormIconComponent, isStandalone: true, selector: "bs-dynamic-form-icon", usesInheritance: true, ngImport: i0, template: "<div class=\"dynamic-form-icon-wrapper\" [ngClass]=\"template.classNameWrapper\">\n  <a\n    *ngIf=\"template.url; else button\"\n    [class]=\"'dynamic-form-icon btn btn-outline-' + (template.color | dynamicFormColor: 'primary')\"\n    [class.disabled]=\"template.disabled\"\n    [ngClass]=\"template.className\"\n    [hidden]=\"template.hidden\"\n    [href]=\"template.url\"\n    [target]=\"template.urlTarget || '_blank'\"\n  >\n    <i class=\"material-icons\">{{ template.icon | dynamicFormIcon }}</i></a\n  >\n\n  <ng-template #button>\n    <button\n      [id]=\"id\"\n      [class]=\"'dynamic-form-icon btn btn-outline-' + (template.color | dynamicFormColor: 'primary')\"\n      [ngClass]=\"template.className\"\n      [type]=\"template.type || 'button'\"\n      [disabled]=\"template.disabled\"\n      [hidden]=\"template.hidden\"\n      (click)=\"onClick($event)\"\n    >\n      <i class=\"material-icons\">{{ template.icon | dynamicFormIcon }}</i></button\n    >\n  </ng-template>\n</div>\n\n<bs-dynamic-form-dialog\n  *ngIf=\"dialog\"\n  [isOpen$]=\"dialogOpen$\"\n  [children]=\"dialogChildren\"\n  [headerActions]=\"dialogHeaderActions\"\n  [footerActions]=\"dialogFooterActions\"\n  [width]=\"template.dialogWidth\"\n  [minWidth]=\"template.dialogMinWidth\"\n  [maxWidth]=\"template.dialogMaxWidth\"\n  [title]=\"template.dialogTitle\"\n  [titleHtml]=\"template.dialogTitleHtml\"\n  [classNameForm]=\"element.root.template.className\"\n  [classNameModal]=\"template.className\"\n  [classNameTitle]=\"template.classNameDialogTitle\"\n  [classNameChildren]=\"dialogTemplate?.classNameChildren\"\n  [classNameHeader]=\"dialogTemplate?.classNameHeader\"\n  [classNameFooter]=\"dialogTemplate?.classNameFooter\"\n/>\n", dependencies: [{ kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "pipe", type: DynamicFormColorPipe, name: "dynamicFormColor" }, { kind: "pipe", type: DynamicFormIconPipe, name: "dynamicFormIcon" }, { kind: "component", type: BsDynamicFormDialogComponent, selector: "bs-dynamic-form-dialog", inputs: ["isOpen$", "children", "headerActions", "footerActions", "width", "height", "minWidth", "minHeight", "maxWidth", "maxHeight", "maximized", "title", "titleHtml", "classNameForm", "classNameModal", "classNameChildren", "classNameHeader", "classNameFooter", "classNameTitle"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormIconComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'bs-dynamic-form-icon', imports: [NgClass, NgIf, DynamicFormColorPipe, DynamicFormIconPipe, BsDynamicFormDialogComponent], template: "<div class=\"dynamic-form-icon-wrapper\" [ngClass]=\"template.classNameWrapper\">\n  <a\n    *ngIf=\"template.url; else button\"\n    [class]=\"'dynamic-form-icon btn btn-outline-' + (template.color | dynamicFormColor: 'primary')\"\n    [class.disabled]=\"template.disabled\"\n    [ngClass]=\"template.className\"\n    [hidden]=\"template.hidden\"\n    [href]=\"template.url\"\n    [target]=\"template.urlTarget || '_blank'\"\n  >\n    <i class=\"material-icons\">{{ template.icon | dynamicFormIcon }}</i></a\n  >\n\n  <ng-template #button>\n    <button\n      [id]=\"id\"\n      [class]=\"'dynamic-form-icon btn btn-outline-' + (template.color | dynamicFormColor: 'primary')\"\n      [ngClass]=\"template.className\"\n      [type]=\"template.type || 'button'\"\n      [disabled]=\"template.disabled\"\n      [hidden]=\"template.hidden\"\n      (click)=\"onClick($event)\"\n    >\n      <i class=\"material-icons\">{{ template.icon | dynamicFormIcon }}</i></button\n    >\n  </ng-template>\n</div>\n\n<bs-dynamic-form-dialog\n  *ngIf=\"dialog\"\n  [isOpen$]=\"dialogOpen$\"\n  [children]=\"dialogChildren\"\n  [headerActions]=\"dialogHeaderActions\"\n  [footerActions]=\"dialogFooterActions\"\n  [width]=\"template.dialogWidth\"\n  [minWidth]=\"template.dialogMinWidth\"\n  [maxWidth]=\"template.dialogMaxWidth\"\n  [title]=\"template.dialogTitle\"\n  [titleHtml]=\"template.dialogTitleHtml\"\n  [classNameForm]=\"element.root.template.className\"\n  [classNameModal]=\"template.className\"\n  [classNameTitle]=\"template.classNameDialogTitle\"\n  [classNameChildren]=\"dialogTemplate?.classNameChildren\"\n  [classNameHeader]=\"dialogTemplate?.classNameHeader\"\n  [classNameFooter]=\"dialogTemplate?.classNameFooter\"\n/>\n" }]
        }], ctorParameters: () => [{ type: i1.DynamicFormActionService }] });

const bsDynamicFormIconType = {
    type: 'icon',
    component: BsDynamicFormIconComponent,
    libraryName: bsDynamicFormLibrary.name,
};

const bsDynamicFormActionTypes = [bsDynamicFormButtonType, bsDynamicFormIconType];
function withBsDynamicFormActionDefaultFeatures() {
    return [withDynamicFormActions(...bsDynamicFormActionTypes)];
}
/**
 * @deprecated Use {@link withBsDynamicFormActionDefaultFeatures} instead.
 */
class BsDynamicFormActionModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormActionModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormActionModule }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormActionModule, providers: importDynamicFormsProviders(...withBsDynamicFormActionDefaultFeatures()) }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormActionModule, decorators: [{
            type: NgModule,
            args: [{ providers: importDynamicFormsProviders(...withBsDynamicFormActionDefaultFeatures()) }]
        }] });

class BsDynamicFormAccordionComponent extends DynamicFormAccordionBase {
    constructor() {
        super();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormAccordionComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.0.1", type: BsDynamicFormAccordionComponent, isStandalone: true, selector: "bs-dynamic-form-accordion", usesInheritance: true, ngImport: i0, template: "<div class=\"dynamic-form-items dynamic-form-accordion accordion\" [ngClass]=\"template.className\" [hidden]=\"template.hidden\">\n  <div *ngFor=\"let child of element.children; let index = index\" class=\"accordion-item\" [hidden]=\"child.template.hidden\">\n    <div class=\"dynamic-form-item-header accordion-header\" [class.disabled]=\"child.disabled\" (click)=\"toggleItem(index)\">\n      <button class=\"accordion-button\" type=\"button\" [class.collapsed]=\"index !== selectedIndex\">{{ child.label }}</button>\n    </div>\n    <div *ngIf=\"index === selectedIndex\" class=\"dynamic-form-item accordion-body\">\n      <dynamic-form-elements [elements]=\"child.children\" />\n    </div>\n  </div>\n</div>\n", dependencies: [{ kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: NgFor, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: DynamicFormElementsComponent, selector: "dynamic-form-elements", inputs: ["elements"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormAccordionComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'bs-dynamic-form-accordion', imports: [NgClass, NgFor, NgIf, DynamicFormElementsComponent], template: "<div class=\"dynamic-form-items dynamic-form-accordion accordion\" [ngClass]=\"template.className\" [hidden]=\"template.hidden\">\n  <div *ngFor=\"let child of element.children; let index = index\" class=\"accordion-item\" [hidden]=\"child.template.hidden\">\n    <div class=\"dynamic-form-item-header accordion-header\" [class.disabled]=\"child.disabled\" (click)=\"toggleItem(index)\">\n      <button class=\"accordion-button\" type=\"button\" [class.collapsed]=\"index !== selectedIndex\">{{ child.label }}</button>\n    </div>\n    <div *ngIf=\"index === selectedIndex\" class=\"dynamic-form-item accordion-body\">\n      <dynamic-form-elements [elements]=\"child.children\" />\n    </div>\n  </div>\n</div>\n" }]
        }], ctorParameters: () => [] });

const bsDynamicFormAccordionType = {
    type: 'accordion',
    factory: dynamicFormItemsFactory,
    component: BsDynamicFormAccordionComponent,
    libraryName: bsDynamicFormLibrary.name,
};
/**
 * @deprecated Use {@link withBsDynamicFormElementDefaultFeatures} instead.
 */
class BsDynamicFormAccordionModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormAccordionModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormAccordionModule }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormAccordionModule, providers: importDynamicFormsProviders(withDynamicFormElements(bsDynamicFormAccordionType)) }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormAccordionModule, decorators: [{
            type: NgModule,
            args: [{ providers: importDynamicFormsProviders(withDynamicFormElements(bsDynamicFormAccordionType)) }]
        }] });

class BsDynamicFormTabsComponent extends DynamicFormTabsBase {
    constructor() {
        super();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormTabsComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.0.1", type: BsDynamicFormTabsComponent, isStandalone: true, selector: "bs-dynamic-form-tabs", usesInheritance: true, ngImport: i0, template: "<div class=\"dynamic-form-items dynamic-form-tabs\" [ngClass]=\"template.className\" [hidden]=\"template.hidden\">\n  <ul class=\"nav nav-tabs\">\n    <li *ngFor=\"let child of element.children; let index = index\" class=\"nav-item\" [hidden]=\"template.hidden\">\n      <button\n        type=\"button\"\n        class=\"dynamic-form-item-header nav-link\"\n        [class.active]=\"index === selectedIndex\"\n        [class.disabled]=\"child.disabled\"\n        (click)=\"selectItem(index)\"\n        >{{ child.label }}</button\n      >\n    </li>\n  </ul>\n  <div class=\"tab-content\">\n    <div *ngIf=\"selectedItem\" class=\"dynamic-form-item tab-pane active\" [hidden]=\"template.hidden\">\n      <dynamic-form-elements [elements]=\"selectedItem.children\" />\n    </div>\n  </div>\n</div>\n", dependencies: [{ kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: NgFor, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: DynamicFormElementsComponent, selector: "dynamic-form-elements", inputs: ["elements"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormTabsComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'bs-dynamic-form-tabs', imports: [NgClass, NgFor, NgIf, DynamicFormElementsComponent], template: "<div class=\"dynamic-form-items dynamic-form-tabs\" [ngClass]=\"template.className\" [hidden]=\"template.hidden\">\n  <ul class=\"nav nav-tabs\">\n    <li *ngFor=\"let child of element.children; let index = index\" class=\"nav-item\" [hidden]=\"template.hidden\">\n      <button\n        type=\"button\"\n        class=\"dynamic-form-item-header nav-link\"\n        [class.active]=\"index === selectedIndex\"\n        [class.disabled]=\"child.disabled\"\n        (click)=\"selectItem(index)\"\n        >{{ child.label }}</button\n      >\n    </li>\n  </ul>\n  <div class=\"tab-content\">\n    <div *ngIf=\"selectedItem\" class=\"dynamic-form-item tab-pane active\" [hidden]=\"template.hidden\">\n      <dynamic-form-elements [elements]=\"selectedItem.children\" />\n    </div>\n  </div>\n</div>\n" }]
        }], ctorParameters: () => [] });

const bsDynamicFormTabsType = {
    type: 'tabs',
    factory: dynamicFormItemsFactory,
    component: BsDynamicFormTabsComponent,
    libraryName: bsDynamicFormLibrary.name,
};
/**
 * @deprecated Use {@link withBsDynamicFormElementDefaultFeatures} instead.
 */
class BsDynamicFormTabsModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormTabsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormTabsModule }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormTabsModule, providers: importDynamicFormsProviders(withDynamicFormElements(bsDynamicFormTabsType)) }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormTabsModule, decorators: [{
            type: NgModule,
            args: [{ providers: importDynamicFormsProviders(withDynamicFormElements(bsDynamicFormTabsType)) }]
        }] });

const modules$5 = [BsDynamicFormAccordionModule, BsDynamicFormTabsModule];
/**
 * @deprecated Use {@link withBsDynamicFormElementDefaultFeatures} instead.
 */
class BsDynamicFormItemsModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormItemsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormItemsModule, imports: [BsDynamicFormAccordionModule, BsDynamicFormTabsModule], exports: [BsDynamicFormAccordionModule, BsDynamicFormTabsModule] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormItemsModule, imports: [modules$5, BsDynamicFormAccordionModule, BsDynamicFormTabsModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormItemsModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: modules$5,
                    exports: modules$5,
                }]
        }] });

class BsDynamicFormModalComponent extends DynamicFormModalBase {
    constructor() {
        super();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormModalComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.0.1", type: BsDynamicFormModalComponent, isStandalone: true, selector: "bs-dynamic-form-modal", usesInheritance: true, ngImport: i0, template: "<dynamic-form-element *ngIf=\"trigger\" [element]=\"trigger\" />\n\n<bs-dynamic-form-dialog\n  [isOpen$]=\"isOpen$\"\n  [children]=\"children\"\n  [headerActions]=\"headerActions\"\n  [footerActions]=\"footerActions\"\n  [width]=\"template.width\"\n  [height]=\"template.height\"\n  [minWidth]=\"template.minWidth\"\n  [minHeight]=\"template.minHeight\"\n  [maxWidth]=\"template.maxWidth\"\n  [maxHeight]=\"template.maxHeight\"\n  [maximized]=\"template.maximized\"\n  [title]=\"template.title\"\n  [titleHtml]=\"template.titleHtml\"\n  [classNameForm]=\"element.root.template.className\"\n  [classNameModal]=\"template.className\"\n  [classNameTitle]=\"template.classNameTitle\"\n  [classNameChildren]=\"template.classNameChildren\"\n  [classNameHeader]=\"template.classNameHeader\"\n  [classNameFooter]=\"template.classNameFooter\"\n/>\n", dependencies: [{ kind: "directive", type: NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: DynamicFormElementComponent, selector: "dynamic-form-element" }, { kind: "component", type: BsDynamicFormDialogComponent, selector: "bs-dynamic-form-dialog", inputs: ["isOpen$", "children", "headerActions", "footerActions", "width", "height", "minWidth", "minHeight", "maxWidth", "maxHeight", "maximized", "title", "titleHtml", "classNameForm", "classNameModal", "classNameChildren", "classNameHeader", "classNameFooter", "classNameTitle"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormModalComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'bs-dynamic-form-modal', imports: [NgIf, DynamicFormElementComponent, BsDynamicFormDialogComponent], template: "<dynamic-form-element *ngIf=\"trigger\" [element]=\"trigger\" />\n\n<bs-dynamic-form-dialog\n  [isOpen$]=\"isOpen$\"\n  [children]=\"children\"\n  [headerActions]=\"headerActions\"\n  [footerActions]=\"footerActions\"\n  [width]=\"template.width\"\n  [height]=\"template.height\"\n  [minWidth]=\"template.minWidth\"\n  [minHeight]=\"template.minHeight\"\n  [maxWidth]=\"template.maxWidth\"\n  [maxHeight]=\"template.maxHeight\"\n  [maximized]=\"template.maximized\"\n  [title]=\"template.title\"\n  [titleHtml]=\"template.titleHtml\"\n  [classNameForm]=\"element.root.template.className\"\n  [classNameModal]=\"template.className\"\n  [classNameTitle]=\"template.classNameTitle\"\n  [classNameChildren]=\"template.classNameChildren\"\n  [classNameHeader]=\"template.classNameHeader\"\n  [classNameFooter]=\"template.classNameFooter\"\n/>\n" }]
        }], ctorParameters: () => [] });

const bsDynamicFormModalType = {
    type: 'modal',
    factory: dynamicFormModalFactory,
    component: BsDynamicFormModalComponent,
    libraryName: bsDynamicFormLibrary.name,
};
const modules$4 = [DynamicFormConfigModule, DynamicFormModalModule];
/**
 * @deprecated Use {@link withBsDynamicFormElementDefaultFeatures} instead.
 */
class BsDynamicFormModalModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormModalModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormModalModule, imports: [DynamicFormConfigModule, DynamicFormModalModule], exports: [DynamicFormConfigModule, DynamicFormModalModule] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormModalModule, providers: importDynamicFormsProviders(withDynamicFormElements(bsDynamicFormModalType)), imports: [modules$4, DynamicFormConfigModule, DynamicFormModalModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormModalModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: modules$4,
                    exports: modules$4,
                    providers: importDynamicFormsProviders(withDynamicFormElements(bsDynamicFormModalType)),
                }]
        }] });

const bsDynamicFormElementTypes = [bsDynamicFormAccordionType, bsDynamicFormTabsType, bsDynamicFormModalType];
function withBsDynamicFormElementDefaultFeatures() {
    return [withDynamicFormElements(...bsDynamicFormElementTypes), withDynamicFormModalActionHandlers()];
}
const modules$3 = [BsDynamicFormItemsModule, BsDynamicFormModalModule];
/**
 * @deprecated Use {@link withBsDynamicFormElementDefaultFeatures} instead.
 */
class BsDynamicFormElementModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormElementModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormElementModule, imports: [BsDynamicFormItemsModule, BsDynamicFormModalModule], exports: [BsDynamicFormItemsModule, BsDynamicFormModalModule] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormElementModule, imports: [modules$3, BsDynamicFormItemsModule, BsDynamicFormModalModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormElementModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: modules$3,
                    exports: modules$3,
                }]
        }] });

class BsDynamicFormControlErrorsComponent extends DynamicFormControlWrapperBase {
    constructor(containerRef, validationService) {
        super(containerRef, validationService);
        this.containerRef = containerRef;
        this.validationService = validationService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormControlErrorsComponent, deps: [{ token: i0.ViewContainerRef }, { token: i1.DynamicFormValidationService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.0.1", type: BsDynamicFormControlErrorsComponent, isStandalone: true, selector: "bs-dynamic-form-control-errors", usesInheritance: true, ngImport: i0, template: "<ng-template #container />\n<div *ngIf=\"showErrors\" class=\"dynamic-form-field-errors invalid-feedback\">{{ errorMessage }}</div>\n", dependencies: [{ kind: "directive", type: NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormControlErrorsComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'bs-dynamic-form-control-errors', imports: [NgIf], template: "<ng-template #container />\n<div *ngIf=\"showErrors\" class=\"dynamic-form-field-errors invalid-feedback\">{{ errorMessage }}</div>\n" }]
        }], ctorParameters: () => [{ type: i0.ViewContainerRef }, { type: i1.DynamicFormValidationService }] });

const bsDynamicFormControlErrorsType = {
    type: 'errors',
    component: BsDynamicFormControlErrorsComponent,
    libraryName: bsDynamicFormLibrary.name,
};
/**
 * @deprecated Use {@link withBsDynamicFormFieldWrapperDefaultFeatures} instead.
 */
class BsDynamicFormControlErrorsModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormControlErrorsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormControlErrorsModule }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormControlErrorsModule, providers: importDynamicFormsProviders(withDynamicFormFieldWrappers(bsDynamicFormControlErrorsType)) }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormControlErrorsModule, decorators: [{
            type: NgModule,
            args: [{ providers: importDynamicFormsProviders(withDynamicFormFieldWrappers(bsDynamicFormControlErrorsType)) }]
        }] });

class BsDynamicFormControlHintsComponent extends DynamicFormControlWrapperBase {
    constructor(containerRef, validationService) {
        super(containerRef, validationService);
        this.containerRef = containerRef;
        this.validationService = validationService;
    }
    get hints() {
        return this.field.template.hints;
    }
    get hasHints() {
        return !!(this.hints?.hintStart || this.hints?.hintEnd);
    }
    get showHints() {
        return this.hasHints && !this.showErrors;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormControlHintsComponent, deps: [{ token: i0.ViewContainerRef }, { token: i1.DynamicFormValidationService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.0.1", type: BsDynamicFormControlHintsComponent, isStandalone: true, selector: "bs-dynamic-form-control-hints", usesInheritance: true, ngImport: i0, template: "<ng-template #container />\n<small *ngIf=\"showHints\" class=\"dynamic-form-field-hints form-text text-muted\">\n  <span *ngIf=\"hints.hintStart\" class=\"hint-start\">{{ hints?.hintStart }}</span>\n  <span class=\"hint-spacer\"></span>\n  <span *ngIf=\"hints.hintEnd\" class=\"hint-end\">{{ hints?.hintEnd }}</span>\n</small>\n", dependencies: [{ kind: "directive", type: NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormControlHintsComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'bs-dynamic-form-control-hints', imports: [NgIf], template: "<ng-template #container />\n<small *ngIf=\"showHints\" class=\"dynamic-form-field-hints form-text text-muted\">\n  <span *ngIf=\"hints.hintStart\" class=\"hint-start\">{{ hints?.hintStart }}</span>\n  <span class=\"hint-spacer\"></span>\n  <span *ngIf=\"hints.hintEnd\" class=\"hint-end\">{{ hints?.hintEnd }}</span>\n</small>\n" }]
        }], ctorParameters: () => [{ type: i0.ViewContainerRef }, { type: i1.DynamicFormValidationService }] });

const bsDynamicFormControlHintsType = {
    type: 'hints',
    component: BsDynamicFormControlHintsComponent,
    libraryName: bsDynamicFormLibrary.name,
};
const modules$2 = [DynamicFormConfigModule];
/**
 * @deprecated Use {@link withBsDynamicFormFieldWrapperDefaultFeatures} instead.
 */
class BsDynamicFormControlHintsModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormControlHintsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormControlHintsModule, imports: [DynamicFormConfigModule], exports: [DynamicFormConfigModule] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormControlHintsModule, providers: importDynamicFormsProviders(withDynamicFormFieldWrappers(bsDynamicFormControlHintsType)), imports: [modules$2, DynamicFormConfigModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormControlHintsModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: modules$2,
                    exports: modules$2,
                    providers: importDynamicFormsProviders(withDynamicFormFieldWrappers(bsDynamicFormControlHintsType)),
                }]
        }] });

class BsDynamicFormControlLabelComponent extends DynamicFormControlWrapperBase {
    constructor(containerRef, validationService) {
        super(containerRef, validationService);
        this.containerRef = containerRef;
        this.validationService = validationService;
    }
    get inputId() {
        return this.field.inputId;
    }
    get validation() {
        return this.field.template.validation;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormControlLabelComponent, deps: [{ token: i0.ViewContainerRef }, { token: i1.DynamicFormValidationService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.0.1", type: BsDynamicFormControlLabelComponent, isStandalone: true, selector: "bs-dynamic-form-control-label", usesInheritance: true, ngImport: i0, template: "<label *ngIf=\"template.label\" class=\"form-label\" [for]=\"inputId\">{{ template.label }}<span *ngIf=\"validation?.required\"> *</span></label>\n<ng-template #container />\n", dependencies: [{ kind: "directive", type: NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormControlLabelComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'bs-dynamic-form-control-label', imports: [NgIf], template: "<label *ngIf=\"template.label\" class=\"form-label\" [for]=\"inputId\">{{ template.label }}<span *ngIf=\"validation?.required\"> *</span></label>\n<ng-template #container />\n" }]
        }], ctorParameters: () => [{ type: i0.ViewContainerRef }, { type: i1.DynamicFormValidationService }] });

const bsDynamicFormControlLabelType = {
    type: 'label',
    component: BsDynamicFormControlLabelComponent,
    libraryName: bsDynamicFormLibrary.name,
};
/**
 * @deprecated Use {@link withBsDynamicFormFieldWrapperDefaultFeatures} instead.
 */
class BsDynamicFormControlLabelModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormControlLabelModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormControlLabelModule }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormControlLabelModule, providers: importDynamicFormsProviders(withDynamicFormFieldWrappers(bsDynamicFormControlLabelType)) }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormControlLabelModule, decorators: [{
            type: NgModule,
            args: [{ providers: importDynamicFormsProviders(withDynamicFormFieldWrappers(bsDynamicFormControlLabelType)) }]
        }] });

const bsDynamicFormFieldWrapperTypes = [
    bsDynamicFormControlErrorsType,
    bsDynamicFormControlHintsType,
    bsDynamicFormControlLabelType,
];
function withBsDynamicFormFieldWrapperDefaultFeatures() {
    return [withDynamicFormFieldWrappers(...bsDynamicFormFieldWrapperTypes)];
}
const modules$1 = [BsDynamicFormControlErrorsModule, BsDynamicFormControlHintsModule, BsDynamicFormControlLabelModule];
/**
 * @deprecated Use {@link withBsDynamicFormFieldWrapperDefaultFeatures} instead.
 */
class BsDynamicFormFieldWrapperModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormFieldWrapperModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormFieldWrapperModule, imports: [BsDynamicFormControlErrorsModule, BsDynamicFormControlHintsModule, BsDynamicFormControlLabelModule], exports: [BsDynamicFormControlErrorsModule, BsDynamicFormControlHintsModule, BsDynamicFormControlLabelModule] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormFieldWrapperModule, imports: [modules$1, BsDynamicFormControlErrorsModule, BsDynamicFormControlHintsModule, BsDynamicFormControlLabelModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormFieldWrapperModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: modules$1,
                    exports: modules$1,
                }]
        }] });

class BsDynamicFormCheckboxComponent extends DynamicFormInputBase {
    constructor(validationService) {
        super(validationService);
        this.validationService = validationService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormCheckboxComponent, deps: [{ token: i1.DynamicFormValidationService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.0.1", type: BsDynamicFormCheckboxComponent, isStandalone: true, selector: "bs-dynamic-form-checkbox", usesInheritance: true, ngImport: i0, template: "<div class=\"form-check\">\n  <input\n    class=\"form-check-input\"\n    type=\"checkbox\"\n    [id]=\"inputId\"\n    [readonly]=\"readonly\"\n    [required]=\"validation?.required\"\n    [indeterminate]=\"input?.indeterminate\"\n    [formControl]=\"control\"\n  />\n  <label class=\"form-check-label\" [for]=\"inputId\">{{ template.label }}<span *ngIf=\"validation?.required\"> *</span></label>\n</div>\n", dependencies: [{ kind: "directive", type: NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i2.CheckboxControlValueAccessor, selector: "input[type=checkbox][formControlName],input[type=checkbox][formControl],input[type=checkbox][ngModel]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.CheckboxRequiredValidator, selector: "input[type=checkbox][required][formControlName],input[type=checkbox][required][formControl],input[type=checkbox][required][ngModel]" }, { kind: "directive", type: i2.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormCheckboxComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'bs-dynamic-form-checkbox', imports: [NgIf, ReactiveFormsModule], template: "<div class=\"form-check\">\n  <input\n    class=\"form-check-input\"\n    type=\"checkbox\"\n    [id]=\"inputId\"\n    [readonly]=\"readonly\"\n    [required]=\"validation?.required\"\n    [indeterminate]=\"input?.indeterminate\"\n    [formControl]=\"control\"\n  />\n  <label class=\"form-check-label\" [for]=\"inputId\">{{ template.label }}<span *ngIf=\"validation?.required\"> *</span></label>\n</div>\n" }]
        }], ctorParameters: () => [{ type: i1.DynamicFormValidationService }] });

const bsDynamicFormCheckboxType = {
    type: 'checkbox',
    component: BsDynamicFormCheckboxComponent,
    wrappers: ['errors'],
    libraryName: bsDynamicFormLibrary.name,
};

class BsDynamicFormInputWrapperComponent {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormInputWrapperComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.0.1", type: BsDynamicFormInputWrapperComponent, isStandalone: true, selector: "bs-dynamic-form-input-wrapper", inputs: { inputTemplate: "inputTemplate", inputId: "inputId", label: "label", labelFloating: "labelFloating", requiredMarker: "requiredMarker", inputAddOn: "inputAddOn", prefixAddOn: "prefixAddOn", suffixAddOn: "suffixAddOn" }, ngImport: i0, template: "<ng-container *ngIf=\"labelFloating; else noLabelFloating\">\n  <div *ngIf=\"inputAddOn || prefixAddOn || suffixAddOn; else noAddOns\" class=\"input-group floating\">\n    <dynamic-form-element\n      *ngIf=\"prefixAddOn && !prefixAddOn.hidden\"\n      class=\"dynamic-form-add-on prefix\"\n      [element]=\"prefixAddOn\"\n      [class.input-group-text]=\"prefixAddOn.classType === 'element'\"\n    />\n    <div class=\"form-floating\">\n      <ng-container *ngTemplateOutlet=\"inputTemplate\" />\n      <label *ngIf=\"label\" class=\"form-label\" [for]=\"inputId\">{{ label }}<span *ngIf=\"requiredMarker\"> *</span></label>\n    </div>\n    <dynamic-form-element\n      *ngIf=\"inputAddOn && !inputAddOn.hidden\"\n      class=\"dynamic-form-add-on suffix\"\n      [element]=\"inputAddOn\"\n      [class.input-group-text]=\"inputAddOn.classType === 'element'\"\n    />\n    <dynamic-form-element\n      *ngIf=\"suffixAddOn && !suffixAddOn.hidden\"\n      class=\"dynamic-form-add-on suffix\"\n      [element]=\"suffixAddOn\"\n      [class.input-group-text]=\"suffixAddOn.classType === 'element'\"\n    />\n  </div>\n  <ng-template #noAddOns>\n    <div class=\"form-floating\">\n      <ng-container *ngTemplateOutlet=\"inputTemplate\" />\n      <label *ngIf=\"label\" class=\"form-label\" [for]=\"inputId\">{{ label }}<span *ngIf=\"requiredMarker\"> *</span></label>\n    </div>\n  </ng-template>\n</ng-container>\n\n<ng-template #noLabelFloating>\n  <label *ngIf=\"label\" class=\"form-label\" [for]=\"inputId\">{{ label }}<span *ngIf=\"requiredMarker\"> *</span></label>\n  <div *ngIf=\"inputAddOn || prefixAddOn || suffixAddOn; else noAddOns\" class=\"input-group\">\n    <dynamic-form-element\n      *ngIf=\"prefixAddOn && !prefixAddOn.hidden\"\n      class=\"dynamic-form-add-on prefix\"\n      [element]=\"prefixAddOn\"\n      [class.input-group-text]=\"prefixAddOn.classType === 'element'\"\n    />\n    <ng-container *ngTemplateOutlet=\"inputTemplate\" />\n    <dynamic-form-element\n      *ngIf=\"inputAddOn && !inputAddOn.hidden\"\n      class=\"dynamic-form-add-on suffix\"\n      [element]=\"inputAddOn\"\n      [class.input-group-text]=\"inputAddOn.classType === 'element'\"\n    />\n    <dynamic-form-element\n      *ngIf=\"suffixAddOn && !suffixAddOn.hidden\"\n      class=\"dynamic-form-add-on suffix\"\n      [element]=\"suffixAddOn\"\n      [class.input-group-text]=\"suffixAddOn.classType === 'element'\"\n    />\n  </div>\n  <ng-template #noAddOns>\n    <ng-container *ngTemplateOutlet=\"inputTemplate\" />\n  </ng-template>\n</ng-template>\n", dependencies: [{ kind: "directive", type: NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "component", type: DynamicFormElementComponent, selector: "dynamic-form-element" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormInputWrapperComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'bs-dynamic-form-input-wrapper', imports: [NgIf, NgTemplateOutlet, DynamicFormElementComponent], template: "<ng-container *ngIf=\"labelFloating; else noLabelFloating\">\n  <div *ngIf=\"inputAddOn || prefixAddOn || suffixAddOn; else noAddOns\" class=\"input-group floating\">\n    <dynamic-form-element\n      *ngIf=\"prefixAddOn && !prefixAddOn.hidden\"\n      class=\"dynamic-form-add-on prefix\"\n      [element]=\"prefixAddOn\"\n      [class.input-group-text]=\"prefixAddOn.classType === 'element'\"\n    />\n    <div class=\"form-floating\">\n      <ng-container *ngTemplateOutlet=\"inputTemplate\" />\n      <label *ngIf=\"label\" class=\"form-label\" [for]=\"inputId\">{{ label }}<span *ngIf=\"requiredMarker\"> *</span></label>\n    </div>\n    <dynamic-form-element\n      *ngIf=\"inputAddOn && !inputAddOn.hidden\"\n      class=\"dynamic-form-add-on suffix\"\n      [element]=\"inputAddOn\"\n      [class.input-group-text]=\"inputAddOn.classType === 'element'\"\n    />\n    <dynamic-form-element\n      *ngIf=\"suffixAddOn && !suffixAddOn.hidden\"\n      class=\"dynamic-form-add-on suffix\"\n      [element]=\"suffixAddOn\"\n      [class.input-group-text]=\"suffixAddOn.classType === 'element'\"\n    />\n  </div>\n  <ng-template #noAddOns>\n    <div class=\"form-floating\">\n      <ng-container *ngTemplateOutlet=\"inputTemplate\" />\n      <label *ngIf=\"label\" class=\"form-label\" [for]=\"inputId\">{{ label }}<span *ngIf=\"requiredMarker\"> *</span></label>\n    </div>\n  </ng-template>\n</ng-container>\n\n<ng-template #noLabelFloating>\n  <label *ngIf=\"label\" class=\"form-label\" [for]=\"inputId\">{{ label }}<span *ngIf=\"requiredMarker\"> *</span></label>\n  <div *ngIf=\"inputAddOn || prefixAddOn || suffixAddOn; else noAddOns\" class=\"input-group\">\n    <dynamic-form-element\n      *ngIf=\"prefixAddOn && !prefixAddOn.hidden\"\n      class=\"dynamic-form-add-on prefix\"\n      [element]=\"prefixAddOn\"\n      [class.input-group-text]=\"prefixAddOn.classType === 'element'\"\n    />\n    <ng-container *ngTemplateOutlet=\"inputTemplate\" />\n    <dynamic-form-element\n      *ngIf=\"inputAddOn && !inputAddOn.hidden\"\n      class=\"dynamic-form-add-on suffix\"\n      [element]=\"inputAddOn\"\n      [class.input-group-text]=\"inputAddOn.classType === 'element'\"\n    />\n    <dynamic-form-element\n      *ngIf=\"suffixAddOn && !suffixAddOn.hidden\"\n      class=\"dynamic-form-add-on suffix\"\n      [element]=\"suffixAddOn\"\n      [class.input-group-text]=\"suffixAddOn.classType === 'element'\"\n    />\n  </div>\n  <ng-template #noAddOns>\n    <ng-container *ngTemplateOutlet=\"inputTemplate\" />\n  </ng-template>\n</ng-template>\n" }]
        }], propDecorators: { inputTemplate: [{
                type: Input
            }], inputId: [{
                type: Input
            }], label: [{
                type: Input
            }], labelFloating: [{
                type: Input
            }], requiredMarker: [{
                type: Input
            }], inputAddOn: [{
                type: Input
            }], prefixAddOn: [{
                type: Input
            }], suffixAddOn: [{
                type: Input
            }] } });

class BsDynamicFormComboboxComponent extends DynamicFormInputBase {
    constructor(validationService) {
        super(validationService);
        this.validationService = validationService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormComboboxComponent, deps: [{ token: i1.DynamicFormValidationService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.0.1", type: BsDynamicFormComboboxComponent, isStandalone: true, selector: "bs-dynamic-form-combobox", usesInheritance: true, ngImport: i0, template: "<bs-dynamic-form-input-wrapper\n  [inputTemplate]=\"inputTemplate\"\n  [inputId]=\"inputId\"\n  [label]=\"template.label\"\n  [labelFloating]=\"template.labelFloating\"\n  [requiredMarker]=\"validation?.required\"\n  [prefixAddOn]=\"prefixAddOn\"\n  [suffixAddOn]=\"suffixAddOn\"\n/>\n\n<ng-template #inputTemplate>\n  <input\n    class=\"form-control\"\n    type=\"text\"\n    list=\"list\"\n    autocomplete=\"off\"\n    [id]=\"inputId\"\n    [placeholder]=\"input.placeholder || ''\"\n    [pattern]=\"input.pattern\"\n    [readonly]=\"readonly\"\n    [required]=\"validation?.required\"\n    [formControl]=\"control\"\n  />\n  <datalist id=\"list\">\n    <option *ngFor=\"let option of input.options\" [value]=\"option\">{{ option }}</option>\n  </datalist>\n</ng-template>\n", dependencies: [{ kind: "directive", type: NgFor, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i2.NgSelectOption, selector: "option", inputs: ["ngValue", "value"] }, { kind: "directive", type: i2.ɵNgSelectMultipleOption, selector: "option", inputs: ["ngValue", "value"] }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.RequiredValidator, selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { kind: "directive", type: i2.PatternValidator, selector: "[pattern][formControlName],[pattern][formControl],[pattern][ngModel]", inputs: ["pattern"] }, { kind: "directive", type: i2.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "component", type: BsDynamicFormInputWrapperComponent, selector: "bs-dynamic-form-input-wrapper", inputs: ["inputTemplate", "inputId", "label", "labelFloating", "requiredMarker", "inputAddOn", "prefixAddOn", "suffixAddOn"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormComboboxComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'bs-dynamic-form-combobox', imports: [NgFor, ReactiveFormsModule, BsDynamicFormInputWrapperComponent], template: "<bs-dynamic-form-input-wrapper\n  [inputTemplate]=\"inputTemplate\"\n  [inputId]=\"inputId\"\n  [label]=\"template.label\"\n  [labelFloating]=\"template.labelFloating\"\n  [requiredMarker]=\"validation?.required\"\n  [prefixAddOn]=\"prefixAddOn\"\n  [suffixAddOn]=\"suffixAddOn\"\n/>\n\n<ng-template #inputTemplate>\n  <input\n    class=\"form-control\"\n    type=\"text\"\n    list=\"list\"\n    autocomplete=\"off\"\n    [id]=\"inputId\"\n    [placeholder]=\"input.placeholder || ''\"\n    [pattern]=\"input.pattern\"\n    [readonly]=\"readonly\"\n    [required]=\"validation?.required\"\n    [formControl]=\"control\"\n  />\n  <datalist id=\"list\">\n    <option *ngFor=\"let option of input.options\" [value]=\"option\">{{ option }}</option>\n  </datalist>\n</ng-template>\n" }]
        }], ctorParameters: () => [{ type: i1.DynamicFormValidationService }] });

const bsDynamicFormComboboxType = {
    type: 'combobox',
    component: BsDynamicFormComboboxComponent,
    wrappers: ['hints', 'errors'],
    libraryName: bsDynamicFormLibrary.name,
};

class BsDynamicFormDatepickerComponent extends DynamicFormInputBase {
    constructor(validationService) {
        super(validationService);
        this.validationService = validationService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormDatepickerComponent, deps: [{ token: i1.DynamicFormValidationService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.0.1", type: BsDynamicFormDatepickerComponent, isStandalone: true, selector: "bs-dynamic-form-datepicker", usesInheritance: true, ngImport: i0, template: "<bs-dynamic-form-input-wrapper\n  [inputTemplate]=\"inputTemplate\"\n  [inputId]=\"inputId\"\n  [label]=\"template.label\"\n  [labelFloating]=\"template.labelFloating\"\n  [requiredMarker]=\"validation?.required\"\n  [prefixAddOn]=\"prefixAddOn\"\n  [suffixAddOn]=\"suffixAddOn\"\n/>\n\n<ng-template #inputTemplate>\n  <input\n    class=\"form-control\"\n    type=\"date\"\n    [id]=\"inputId\"\n    [placeholder]=\"input.placeholder\"\n    [min]=\"input.minDate\"\n    [max]=\"input.maxDate\"\n    [readonly]=\"readonly\"\n    [required]=\"validation?.required\"\n    [formControl]=\"control\"\n  />\n</ng-template>\n", dependencies: [{ kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.RequiredValidator, selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { kind: "directive", type: i2.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "component", type: BsDynamicFormInputWrapperComponent, selector: "bs-dynamic-form-input-wrapper", inputs: ["inputTemplate", "inputId", "label", "labelFloating", "requiredMarker", "inputAddOn", "prefixAddOn", "suffixAddOn"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormDatepickerComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'bs-dynamic-form-datepicker', imports: [ReactiveFormsModule, BsDynamicFormInputWrapperComponent], template: "<bs-dynamic-form-input-wrapper\n  [inputTemplate]=\"inputTemplate\"\n  [inputId]=\"inputId\"\n  [label]=\"template.label\"\n  [labelFloating]=\"template.labelFloating\"\n  [requiredMarker]=\"validation?.required\"\n  [prefixAddOn]=\"prefixAddOn\"\n  [suffixAddOn]=\"suffixAddOn\"\n/>\n\n<ng-template #inputTemplate>\n  <input\n    class=\"form-control\"\n    type=\"date\"\n    [id]=\"inputId\"\n    [placeholder]=\"input.placeholder\"\n    [min]=\"input.minDate\"\n    [max]=\"input.maxDate\"\n    [readonly]=\"readonly\"\n    [required]=\"validation?.required\"\n    [formControl]=\"control\"\n  />\n</ng-template>\n" }]
        }], ctorParameters: () => [{ type: i1.DynamicFormValidationService }] });

const bsDynamicFormDatepickerType = {
    type: 'datepicker',
    component: BsDynamicFormDatepickerComponent,
    wrappers: ['hints', 'errors'],
    libraryName: bsDynamicFormLibrary.name,
};

class BsDynamicFormFileComponent extends DynamicFormFileBase {
    constructor(builder, validationService) {
        super(builder, validationService);
        this.builder = builder;
        this.validationService = validationService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormFileComponent, deps: [{ token: i1.DynamicFormBuilder }, { token: i1.DynamicFormValidationService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.0.1", type: BsDynamicFormFileComponent, isStandalone: true, selector: "bs-dynamic-form-file", usesInheritance: true, ngImport: i0, template: "<bs-dynamic-form-input-wrapper\n  #wrapper\n  [inputTemplate]=\"inputTemplate\"\n  [inputId]=\"inputId\"\n  [label]=\"template.label\"\n  [labelFloating]=\"template.labelFloating\"\n  [requiredMarker]=\"validation?.required\"\n  [inputAddOn]=\"uploadAction\"\n  [prefixAddOn]=\"prefixAddOn\"\n  [suffixAddOn]=\"suffixAddOn\"\n/>\n\n<ng-template #inputTemplate>\n  <input\n    class=\"form-control\"\n    type=\"text\"\n    readonly\n    [id]=\"inputId\"\n    [placeholder]=\"input.placeholder || ''\"\n    [value]=\"fileDirective.fileNamesAsText || ''\"\n    [disabled]=\"control.disabled\"\n    (blur)=\"control.markAsTouched()\"\n  />\n  <input\n    #fileDirective=\"dynamicFormFile\"\n    dynamicFormFile\n    [acceptFiles]=\"input.accept\"\n    [multipleFiles]=\"input.multiple\"\n    [formControl]=\"control\"\n  />\n</ng-template>\n", dependencies: [{ kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "directive", type: DynamicFormFileDirective, selector: "[dynamicFormFile]", inputs: ["acceptFiles", "multipleFiles"], exportAs: ["dynamicFormFile"] }, { kind: "component", type: BsDynamicFormInputWrapperComponent, selector: "bs-dynamic-form-input-wrapper", inputs: ["inputTemplate", "inputId", "label", "labelFloating", "requiredMarker", "inputAddOn", "prefixAddOn", "suffixAddOn"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormFileComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'bs-dynamic-form-file', imports: [ReactiveFormsModule, DynamicFormFileDirective, BsDynamicFormInputWrapperComponent], template: "<bs-dynamic-form-input-wrapper\n  #wrapper\n  [inputTemplate]=\"inputTemplate\"\n  [inputId]=\"inputId\"\n  [label]=\"template.label\"\n  [labelFloating]=\"template.labelFloating\"\n  [requiredMarker]=\"validation?.required\"\n  [inputAddOn]=\"uploadAction\"\n  [prefixAddOn]=\"prefixAddOn\"\n  [suffixAddOn]=\"suffixAddOn\"\n/>\n\n<ng-template #inputTemplate>\n  <input\n    class=\"form-control\"\n    type=\"text\"\n    readonly\n    [id]=\"inputId\"\n    [placeholder]=\"input.placeholder || ''\"\n    [value]=\"fileDirective.fileNamesAsText || ''\"\n    [disabled]=\"control.disabled\"\n    (blur)=\"control.markAsTouched()\"\n  />\n  <input\n    #fileDirective=\"dynamicFormFile\"\n    dynamicFormFile\n    [acceptFiles]=\"input.accept\"\n    [multipleFiles]=\"input.multiple\"\n    [formControl]=\"control\"\n  />\n</ng-template>\n" }]
        }], ctorParameters: () => [{ type: i1.DynamicFormBuilder }, { type: i1.DynamicFormValidationService }] });

const bsDynamicFormFileType = {
    type: 'file',
    component: BsDynamicFormFileComponent,
    wrappers: ['hints', 'errors'],
    libraryName: bsDynamicFormLibrary.name,
};

class BsDynamicFormNumberboxComponent extends DynamicFormInputBase {
    constructor(validationService) {
        super(validationService);
        this.validationService = validationService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormNumberboxComponent, deps: [{ token: i1.DynamicFormValidationService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.0.1", type: BsDynamicFormNumberboxComponent, isStandalone: true, selector: "bs-dynamic-form-numberbox", usesInheritance: true, ngImport: i0, template: "<bs-dynamic-form-input-wrapper\n  [inputTemplate]=\"inputTemplate\"\n  [inputId]=\"inputId\"\n  [label]=\"template.label\"\n  [labelFloating]=\"template.labelFloating\"\n  [requiredMarker]=\"validation?.required\"\n  [prefixAddOn]=\"prefixAddOn\"\n  [suffixAddOn]=\"suffixAddOn\"\n/>\n\n<ng-template #inputTemplate>\n  <input\n    class=\"form-control\"\n    type=\"number\"\n    [id]=\"inputId\"\n    [placeholder]=\"input.placeholder || ''\"\n    [min]=\"input.min\"\n    [max]=\"input.max\"\n    [readonly]=\"readonly\"\n    [required]=\"validation?.required\"\n    [formControl]=\"control\"\n  />\n</ng-template>\n", dependencies: [{ kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NumberValueAccessor, selector: "input[type=number][formControlName],input[type=number][formControl],input[type=number][ngModel]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.RequiredValidator, selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { kind: "directive", type: i2.MinValidator, selector: "input[type=number][min][formControlName],input[type=number][min][formControl],input[type=number][min][ngModel]", inputs: ["min"] }, { kind: "directive", type: i2.MaxValidator, selector: "input[type=number][max][formControlName],input[type=number][max][formControl],input[type=number][max][ngModel]", inputs: ["max"] }, { kind: "directive", type: i2.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "component", type: BsDynamicFormInputWrapperComponent, selector: "bs-dynamic-form-input-wrapper", inputs: ["inputTemplate", "inputId", "label", "labelFloating", "requiredMarker", "inputAddOn", "prefixAddOn", "suffixAddOn"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormNumberboxComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'bs-dynamic-form-numberbox', imports: [ReactiveFormsModule, BsDynamicFormInputWrapperComponent], template: "<bs-dynamic-form-input-wrapper\n  [inputTemplate]=\"inputTemplate\"\n  [inputId]=\"inputId\"\n  [label]=\"template.label\"\n  [labelFloating]=\"template.labelFloating\"\n  [requiredMarker]=\"validation?.required\"\n  [prefixAddOn]=\"prefixAddOn\"\n  [suffixAddOn]=\"suffixAddOn\"\n/>\n\n<ng-template #inputTemplate>\n  <input\n    class=\"form-control\"\n    type=\"number\"\n    [id]=\"inputId\"\n    [placeholder]=\"input.placeholder || ''\"\n    [min]=\"input.min\"\n    [max]=\"input.max\"\n    [readonly]=\"readonly\"\n    [required]=\"validation?.required\"\n    [formControl]=\"control\"\n  />\n</ng-template>\n" }]
        }], ctorParameters: () => [{ type: i1.DynamicFormValidationService }] });

const bsDynamicFormNumberboxType = {
    type: 'numberbox',
    component: BsDynamicFormNumberboxComponent,
    wrappers: ['hints', 'errors'],
    libraryName: bsDynamicFormLibrary.name,
};

class BsDynamicFormRadioComponent extends DynamicFormInputBase {
    constructor(validationService) {
        super(validationService);
        this.validationService = validationService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormRadioComponent, deps: [{ token: i1.DynamicFormValidationService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.0.1", type: BsDynamicFormRadioComponent, isStandalone: true, selector: "bs-dynamic-form-radio", usesInheritance: true, ngImport: i0, template: "<ng-container *ngFor=\"let option of input.options; let i = index\">\n  <div class=\"form-check\">\n    <input\n      class=\"form-check-input\"\n      type=\"radio\"\n      [id]=\"inputId + '-' + i\"\n      [name]=\"inputId\"\n      [formControl]=\"control\"\n      [value]=\"option.value\"\n      [attr.disabled]=\"control.disabled || option.disabled\"\n      [readonly]=\"readonly\"\n    />\n    <label class=\"form-check-label\" [for]=\"inputId + '-' + i\">{{ option.label }}</label>\n  </div>\n</ng-container>\n", dependencies: [{ kind: "directive", type: NgFor, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.RadioControlValueAccessor, selector: "input[type=radio][formControlName],input[type=radio][formControl],input[type=radio][ngModel]", inputs: ["name", "formControlName", "value"] }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormRadioComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'bs-dynamic-form-radio', imports: [NgFor, ReactiveFormsModule], template: "<ng-container *ngFor=\"let option of input.options; let i = index\">\n  <div class=\"form-check\">\n    <input\n      class=\"form-check-input\"\n      type=\"radio\"\n      [id]=\"inputId + '-' + i\"\n      [name]=\"inputId\"\n      [formControl]=\"control\"\n      [value]=\"option.value\"\n      [attr.disabled]=\"control.disabled || option.disabled\"\n      [readonly]=\"readonly\"\n    />\n    <label class=\"form-check-label\" [for]=\"inputId + '-' + i\">{{ option.label }}</label>\n  </div>\n</ng-container>\n" }]
        }], ctorParameters: () => [{ type: i1.DynamicFormValidationService }] });

const bsDynamicFormRadioType = {
    type: 'radio',
    component: BsDynamicFormRadioComponent,
    wrappers: ['label', 'errors'],
    libraryName: bsDynamicFormLibrary.name,
};

class BsDynamicFormSelectComponent extends DynamicFormInputBase {
    constructor(validationService) {
        super(validationService);
        this.validationService = validationService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormSelectComponent, deps: [{ token: i1.DynamicFormValidationService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.0.1", type: BsDynamicFormSelectComponent, isStandalone: true, selector: "bs-dynamic-form-select", usesInheritance: true, ngImport: i0, template: "<bs-dynamic-form-input-wrapper\n  [inputTemplate]=\"inputTemplate\"\n  [inputId]=\"inputId\"\n  [label]=\"template.label\"\n  [labelFloating]=\"template.labelFloating\"\n  [requiredMarker]=\"validation?.required\"\n  [prefixAddOn]=\"prefixAddOn\"\n  [suffixAddOn]=\"suffixAddOn\"\n/>\n\n<ng-template #inputTemplate>\n  <ng-container *ngIf=\"!input.multiple; else optionsMultiple\">\n    <select class=\"form-select\" [id]=\"inputId\" [required]=\"validation?.required\" [formControl]=\"control\">\n      <option hidden [value]=\"null\">{{ input.placeholder }}</option>\n      <ng-container *ngFor=\"let option of input.options\">\n        <ng-container *ngIf=\"!option.items; else optionGroup\">\n          <option [value]=\"option.value\" [disabled]=\"option.disabled\">{{ option.label }}</option>\n        </ng-container>\n        <ng-template #optionGroup>\n          <optgroup [label]=\"option.label\" [disabled]=\"option.disabled\">\n            <option *ngFor=\"let optionItem of option.items\" [value]=\"optionItem.value\" [disabled]=\"optionItem.disabled\">{{\n              optionItem.label\n            }}</option>\n          </optgroup>\n        </ng-template>\n      </ng-container>\n    </select>\n  </ng-container>\n\n  <ng-template #optionsMultiple>\n    <select class=\"form-select\" multiple [id]=\"inputId\" [required]=\"validation?.required\" [formControl]=\"control\">\n      <ng-container *ngFor=\"let option of input.options\">\n        <ng-container *ngIf=\"!option.items; else optionGroup\">\n          <option [value]=\"option.value\" [disabled]=\"option.disabled\">{{ option.label }}</option>\n        </ng-container>\n        <ng-template #optionGroup>\n          <optgroup [label]=\"option.label\" [disabled]=\"option.disabled\">\n            <option *ngFor=\"let optionItem of option.items\" [value]=\"optionItem.value\" [disabled]=\"optionItem.disabled\">{{\n              optionItem.label\n            }}</option>\n          </optgroup>\n        </ng-template>\n      </ng-container>\n    </select>\n  </ng-template>\n</ng-template>\n", dependencies: [{ kind: "directive", type: NgFor, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i2.NgSelectOption, selector: "option", inputs: ["ngValue", "value"] }, { kind: "directive", type: i2.ɵNgSelectMultipleOption, selector: "option", inputs: ["ngValue", "value"] }, { kind: "directive", type: i2.SelectControlValueAccessor, selector: "select:not([multiple])[formControlName],select:not([multiple])[formControl],select:not([multiple])[ngModel]", inputs: ["compareWith"] }, { kind: "directive", type: i2.SelectMultipleControlValueAccessor, selector: "select[multiple][formControlName],select[multiple][formControl],select[multiple][ngModel]", inputs: ["compareWith"] }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.RequiredValidator, selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { kind: "directive", type: i2.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "component", type: BsDynamicFormInputWrapperComponent, selector: "bs-dynamic-form-input-wrapper", inputs: ["inputTemplate", "inputId", "label", "labelFloating", "requiredMarker", "inputAddOn", "prefixAddOn", "suffixAddOn"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormSelectComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'bs-dynamic-form-select', imports: [NgFor, NgIf, ReactiveFormsModule, BsDynamicFormInputWrapperComponent], template: "<bs-dynamic-form-input-wrapper\n  [inputTemplate]=\"inputTemplate\"\n  [inputId]=\"inputId\"\n  [label]=\"template.label\"\n  [labelFloating]=\"template.labelFloating\"\n  [requiredMarker]=\"validation?.required\"\n  [prefixAddOn]=\"prefixAddOn\"\n  [suffixAddOn]=\"suffixAddOn\"\n/>\n\n<ng-template #inputTemplate>\n  <ng-container *ngIf=\"!input.multiple; else optionsMultiple\">\n    <select class=\"form-select\" [id]=\"inputId\" [required]=\"validation?.required\" [formControl]=\"control\">\n      <option hidden [value]=\"null\">{{ input.placeholder }}</option>\n      <ng-container *ngFor=\"let option of input.options\">\n        <ng-container *ngIf=\"!option.items; else optionGroup\">\n          <option [value]=\"option.value\" [disabled]=\"option.disabled\">{{ option.label }}</option>\n        </ng-container>\n        <ng-template #optionGroup>\n          <optgroup [label]=\"option.label\" [disabled]=\"option.disabled\">\n            <option *ngFor=\"let optionItem of option.items\" [value]=\"optionItem.value\" [disabled]=\"optionItem.disabled\">{{\n              optionItem.label\n            }}</option>\n          </optgroup>\n        </ng-template>\n      </ng-container>\n    </select>\n  </ng-container>\n\n  <ng-template #optionsMultiple>\n    <select class=\"form-select\" multiple [id]=\"inputId\" [required]=\"validation?.required\" [formControl]=\"control\">\n      <ng-container *ngFor=\"let option of input.options\">\n        <ng-container *ngIf=\"!option.items; else optionGroup\">\n          <option [value]=\"option.value\" [disabled]=\"option.disabled\">{{ option.label }}</option>\n        </ng-container>\n        <ng-template #optionGroup>\n          <optgroup [label]=\"option.label\" [disabled]=\"option.disabled\">\n            <option *ngFor=\"let optionItem of option.items\" [value]=\"optionItem.value\" [disabled]=\"optionItem.disabled\">{{\n              optionItem.label\n            }}</option>\n          </optgroup>\n        </ng-template>\n      </ng-container>\n    </select>\n  </ng-template>\n</ng-template>\n" }]
        }], ctorParameters: () => [{ type: i1.DynamicFormValidationService }] });

const bsDynamicFormSelectType = {
    type: 'select',
    component: BsDynamicFormSelectComponent,
    wrappers: ['hints', 'errors'],
    libraryName: bsDynamicFormLibrary.name,
};

class BsDynamicFormSwitchComponent extends DynamicFormInputBase {
    constructor(validationService) {
        super(validationService);
        this.validationService = validationService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormSwitchComponent, deps: [{ token: i1.DynamicFormValidationService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.0.1", type: BsDynamicFormSwitchComponent, isStandalone: true, selector: "bs-dynamic-form-switch", usesInheritance: true, ngImport: i0, template: "<div class=\"form-check form-switch\">\n  <input\n    class=\"form-check-input\"\n    type=\"checkbox\"\n    [id]=\"inputId\"\n    [readonly]=\"readonly\"\n    [required]=\"validation?.required\"\n    [formControl]=\"control\"\n  />\n  <label class=\"form-check-label\" [for]=\"inputId\">{{ template.label }}<span *ngIf=\"validation?.required\"> *</span></label>\n</div>\n", dependencies: [{ kind: "directive", type: NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i2.CheckboxControlValueAccessor, selector: "input[type=checkbox][formControlName],input[type=checkbox][formControl],input[type=checkbox][ngModel]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.CheckboxRequiredValidator, selector: "input[type=checkbox][required][formControlName],input[type=checkbox][required][formControl],input[type=checkbox][required][ngModel]" }, { kind: "directive", type: i2.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormSwitchComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'bs-dynamic-form-switch', imports: [NgIf, ReactiveFormsModule], template: "<div class=\"form-check form-switch\">\n  <input\n    class=\"form-check-input\"\n    type=\"checkbox\"\n    [id]=\"inputId\"\n    [readonly]=\"readonly\"\n    [required]=\"validation?.required\"\n    [formControl]=\"control\"\n  />\n  <label class=\"form-check-label\" [for]=\"inputId\">{{ template.label }}<span *ngIf=\"validation?.required\"> *</span></label>\n</div>\n" }]
        }], ctorParameters: () => [{ type: i1.DynamicFormValidationService }] });

const bsDynamicFormSwitchType = {
    type: 'switch',
    component: BsDynamicFormSwitchComponent,
    wrappers: ['errors'],
    libraryName: bsDynamicFormLibrary.name,
};

class BsDynamicFormTextareaComponent extends DynamicFormInputBase {
    constructor(validationService) {
        super(validationService);
        this.validationService = validationService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormTextareaComponent, deps: [{ token: i1.DynamicFormValidationService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.0.1", type: BsDynamicFormTextareaComponent, isStandalone: true, selector: "bs-dynamic-form-textarea", usesInheritance: true, ngImport: i0, template: "<bs-dynamic-form-input-wrapper\n  [inputTemplate]=\"inputTemplate\"\n  [inputId]=\"inputId\"\n  [label]=\"template.label\"\n  [labelFloating]=\"template.labelFloating\"\n  [requiredMarker]=\"validation?.required\"\n  [prefixAddOn]=\"prefixAddOn\"\n  [suffixAddOn]=\"suffixAddOn\"\n/>\n\n<ng-template #inputTemplate>\n  <textarea\n    class=\"form-control\"\n    [id]=\"inputId\"\n    [placeholder]=\"input.placeholder || ''\"\n    [pattern]=\"input.pattern\"\n    [readonly]=\"readonly\"\n    [required]=\"validation?.required\"\n    [formControl]=\"control\"\n  ></textarea>\n</ng-template>\n", dependencies: [{ kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.RequiredValidator, selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { kind: "directive", type: i2.PatternValidator, selector: "[pattern][formControlName],[pattern][formControl],[pattern][ngModel]", inputs: ["pattern"] }, { kind: "directive", type: i2.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "component", type: BsDynamicFormInputWrapperComponent, selector: "bs-dynamic-form-input-wrapper", inputs: ["inputTemplate", "inputId", "label", "labelFloating", "requiredMarker", "inputAddOn", "prefixAddOn", "suffixAddOn"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormTextareaComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'bs-dynamic-form-textarea', imports: [ReactiveFormsModule, BsDynamicFormInputWrapperComponent], template: "<bs-dynamic-form-input-wrapper\n  [inputTemplate]=\"inputTemplate\"\n  [inputId]=\"inputId\"\n  [label]=\"template.label\"\n  [labelFloating]=\"template.labelFloating\"\n  [requiredMarker]=\"validation?.required\"\n  [prefixAddOn]=\"prefixAddOn\"\n  [suffixAddOn]=\"suffixAddOn\"\n/>\n\n<ng-template #inputTemplate>\n  <textarea\n    class=\"form-control\"\n    [id]=\"inputId\"\n    [placeholder]=\"input.placeholder || ''\"\n    [pattern]=\"input.pattern\"\n    [readonly]=\"readonly\"\n    [required]=\"validation?.required\"\n    [formControl]=\"control\"\n  ></textarea>\n</ng-template>\n" }]
        }], ctorParameters: () => [{ type: i1.DynamicFormValidationService }] });

const bsDynamicFormTextareaType = {
    type: 'textarea',
    component: BsDynamicFormTextareaComponent,
    wrappers: ['hints', 'errors'],
    libraryName: bsDynamicFormLibrary.name,
};

class BsDynamicFormTextboxComponent extends DynamicFormInputBase {
    constructor(validationService) {
        super(validationService);
        this.validationService = validationService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormTextboxComponent, deps: [{ token: i1.DynamicFormValidationService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.0.1", type: BsDynamicFormTextboxComponent, isStandalone: true, selector: "bs-dynamic-form-textbox", usesInheritance: true, ngImport: i0, template: "<bs-dynamic-form-input-wrapper\n  [inputTemplate]=\"inputTemplate\"\n  [inputId]=\"inputId\"\n  [label]=\"template.label\"\n  [labelFloating]=\"template.labelFloating\"\n  [requiredMarker]=\"validation?.required\"\n  [prefixAddOn]=\"prefixAddOn\"\n  [suffixAddOn]=\"suffixAddOn\"\n/>\n\n<ng-template #inputTemplate>\n  <input\n    class=\"form-control\"\n    [id]=\"inputId\"\n    [type]=\"input.inputTypeForced || input.inputType\"\n    [placeholder]=\"input.placeholder || ''\"\n    [pattern]=\"input.pattern\"\n    [readonly]=\"readonly\"\n    [required]=\"validation?.required\"\n    [formControl]=\"control\"\n  />\n</ng-template>\n", dependencies: [{ kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.RequiredValidator, selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { kind: "directive", type: i2.PatternValidator, selector: "[pattern][formControlName],[pattern][formControl],[pattern][ngModel]", inputs: ["pattern"] }, { kind: "directive", type: i2.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "component", type: BsDynamicFormInputWrapperComponent, selector: "bs-dynamic-form-input-wrapper", inputs: ["inputTemplate", "inputId", "label", "labelFloating", "requiredMarker", "inputAddOn", "prefixAddOn", "suffixAddOn"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormTextboxComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'bs-dynamic-form-textbox', imports: [ReactiveFormsModule, BsDynamicFormInputWrapperComponent], template: "<bs-dynamic-form-input-wrapper\n  [inputTemplate]=\"inputTemplate\"\n  [inputId]=\"inputId\"\n  [label]=\"template.label\"\n  [labelFloating]=\"template.labelFloating\"\n  [requiredMarker]=\"validation?.required\"\n  [prefixAddOn]=\"prefixAddOn\"\n  [suffixAddOn]=\"suffixAddOn\"\n/>\n\n<ng-template #inputTemplate>\n  <input\n    class=\"form-control\"\n    [id]=\"inputId\"\n    [type]=\"input.inputTypeForced || input.inputType\"\n    [placeholder]=\"input.placeholder || ''\"\n    [pattern]=\"input.pattern\"\n    [readonly]=\"readonly\"\n    [required]=\"validation?.required\"\n    [formControl]=\"control\"\n  />\n</ng-template>\n" }]
        }], ctorParameters: () => [{ type: i1.DynamicFormValidationService }] });

const bsDynamicFormTextboxType = {
    type: 'textbox',
    component: BsDynamicFormTextboxComponent,
    wrappers: ['hints', 'errors'],
    libraryName: bsDynamicFormLibrary.name,
};

class BsDynamicFormToggleComponent extends DynamicFormInputBase {
    constructor(validationService) {
        super(validationService);
        this.validationService = validationService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormToggleComponent, deps: [{ token: i1.DynamicFormValidationService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "18.0.1", type: BsDynamicFormToggleComponent, isStandalone: true, selector: "bs-dynamic-form-toggle", usesInheritance: true, ngImport: i0, template: "<div class=\"btn-group btn-group-toggle\">\n  <ng-container *ngFor=\"let option of input.options; let i = index\">\n    <input\n      class=\"btn-check\"\n      type=\"radio\"\n      autocomplete=\"off\"\n      [id]=\"inputId + '-' + i\"\n      [name]=\"inputId\"\n      [formControl]=\"control\"\n      [value]=\"option.value\"\n      [attr.disabled]=\"control.disabled || option.disabled\"\n      [readonly]=\"readonly\"\n    />\n    <label\n      class=\"btn btn-outline-light\"\n      [for]=\"inputId + '-' + i\"\n      [class.disabled]=\"control.disabled || option.disabled\"\n      [class.active]=\"control.value === option.value\"\n      >{{ option.label }}</label\n    >\n  </ng-container>\n</div>\n", dependencies: [{ kind: "directive", type: NgFor, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i2.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2.RadioControlValueAccessor, selector: "input[type=radio][formControlName],input[type=radio][formControl],input[type=radio][ngModel]", inputs: ["name", "formControlName", "value"] }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormToggleComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'bs-dynamic-form-toggle', imports: [NgFor, ReactiveFormsModule], template: "<div class=\"btn-group btn-group-toggle\">\n  <ng-container *ngFor=\"let option of input.options; let i = index\">\n    <input\n      class=\"btn-check\"\n      type=\"radio\"\n      autocomplete=\"off\"\n      [id]=\"inputId + '-' + i\"\n      [name]=\"inputId\"\n      [formControl]=\"control\"\n      [value]=\"option.value\"\n      [attr.disabled]=\"control.disabled || option.disabled\"\n      [readonly]=\"readonly\"\n    />\n    <label\n      class=\"btn btn-outline-light\"\n      [for]=\"inputId + '-' + i\"\n      [class.disabled]=\"control.disabled || option.disabled\"\n      [class.active]=\"control.value === option.value\"\n      >{{ option.label }}</label\n    >\n  </ng-container>\n</div>\n" }]
        }], ctorParameters: () => [{ type: i1.DynamicFormValidationService }] });

const bsDynamicFormToggleType = {
    type: 'toggle',
    component: BsDynamicFormToggleComponent,
    wrappers: ['label', 'errors'],
    libraryName: bsDynamicFormLibrary.name,
};

const bsDynamicFormInputTypes = [
    bsDynamicFormCheckboxType,
    bsDynamicFormComboboxType,
    bsDynamicFormDatepickerType,
    bsDynamicFormFileType,
    bsDynamicFormNumberboxType,
    bsDynamicFormRadioType,
    bsDynamicFormSelectType,
    bsDynamicFormSwitchType,
    bsDynamicFormTextareaType,
    bsDynamicFormTextboxType,
    bsDynamicFormToggleType,
];
function withBsDynamicFormInputDefaultFeatures() {
    return [
        withDynamicFormInputs(...bsDynamicFormInputTypes),
        withDynamicFormTextboxActionHandlers(),
        withDynamicFormFileValidators(),
        withDynamicFormNativeDateConverter(),
        ...withDynamicFormDatepickerValidators(),
    ];
}
const modules = [DynamicFormFileModule, DynamicFormTextboxModule];
/**
 * @deprecated Use {@link withBsDynamicFormInputDefaultFeatures} instead.
 */
class BsDynamicFormInputModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormInputModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormInputModule, imports: [DynamicFormFileModule, DynamicFormTextboxModule], exports: [DynamicFormFileModule, DynamicFormTextboxModule] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormInputModule, providers: importDynamicFormsProviders(withDynamicFormInputs(...bsDynamicFormInputTypes)), imports: [modules, DynamicFormFileModule, DynamicFormTextboxModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormInputModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: modules,
                    exports: modules,
                    providers: importDynamicFormsProviders(withDynamicFormInputs(...bsDynamicFormInputTypes)),
                }]
        }] });

function provideBsDynamicForms(...features) {
    return [provideDynamicForms(bsDynamicFormLibrary, ...features)];
}
const bsDynamicFormsDefaultFeatures = [
    withDynamicFormValidation(),
    ...withBsDynamicFormActionDefaultFeatures(),
    ...withBsDynamicFormElementDefaultFeatures(),
    ...withBsDynamicFormFieldWrapperDefaultFeatures(),
    ...withBsDynamicFormInputDefaultFeatures(),
];
function getDynamicFormsFeatures(config) {
    const features = [];
    if (config?.theme) {
        features.push(withDynamicFormsTheme(config?.theme));
    }
    if (config?.idBuilder) {
        features.push(withDynamicFormsIdBuilder(config?.idBuilder));
    }
    return features;
}
function provideBsDynamicFormsWithDefaultFeatures(config, ...additionalFeatures) {
    const features = [...bsDynamicFormsDefaultFeatures, ...getDynamicFormsFeatures(config), ...additionalFeatures];
    return provideDynamicFormsWithDefaultFeatures(bsDynamicFormLibrary, ...features);
}
/**
 * @deprecated Use {@link provideBsDynamicFormsWithDefaultFeatures} instead.
 */
class BsDynamicFormsModule {
    /**
     * @deprecated Use {@link provideBsDynamicFormsWithDefaultFeatures} instead.
     */
    static forRoot(config, ...additionalFeatures) {
        const features = [withDynamicFormsLibrary(bsDynamicFormLibrary), ...getDynamicFormsFeatures(config), ...additionalFeatures];
        return { ngModule: BsDynamicFormsModule, providers: importDynamicFormsProviders(...features) };
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormsModule, imports: [DynamicFormsModule], exports: [DynamicFormsModule] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormsModule, providers: provideDynamicFormsWithDefaultFeatures(null, ...bsDynamicFormsDefaultFeatures, withDynamicFormValidation()), imports: [DynamicFormsModule, DynamicFormsModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.0.1", ngImport: i0, type: BsDynamicFormsModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [DynamicFormsModule],
                    exports: [DynamicFormsModule],
                    providers: provideDynamicFormsWithDefaultFeatures(null, ...bsDynamicFormsDefaultFeatures, withDynamicFormValidation()),
                }]
        }] });

/*
 * Public API Surface of material
 */

/**
 * Generated bundle index. Do not edit.
 */

export { BsDynamicFormAccordionComponent, BsDynamicFormAccordionModule, BsDynamicFormActionModule, BsDynamicFormButtonComponent, BsDynamicFormCheckboxComponent, BsDynamicFormComboboxComponent, BsDynamicFormControlErrorsComponent, BsDynamicFormControlErrorsModule, BsDynamicFormControlHintsComponent, BsDynamicFormControlHintsModule, BsDynamicFormControlLabelComponent, BsDynamicFormControlLabelModule, BsDynamicFormDatepickerComponent, BsDynamicFormDialogComponent, BsDynamicFormElementModule, BsDynamicFormFieldWrapperModule, BsDynamicFormFileComponent, BsDynamicFormIconComponent, BsDynamicFormInputModule, BsDynamicFormInputWrapperComponent, BsDynamicFormItemsModule, BsDynamicFormModalComponent, BsDynamicFormModalModule, BsDynamicFormNumberboxComponent, BsDynamicFormRadioComponent, BsDynamicFormSelectComponent, BsDynamicFormTabsComponent, BsDynamicFormTabsModule, BsDynamicFormTextareaComponent, BsDynamicFormTextboxComponent, BsDynamicFormsModule, bsDynamicFormAccordionType, bsDynamicFormActionTypes, bsDynamicFormButtonType, bsDynamicFormCheckboxType, bsDynamicFormComboboxType, bsDynamicFormControlErrorsType, bsDynamicFormControlHintsType, bsDynamicFormControlLabelType, bsDynamicFormDatepickerType, bsDynamicFormElementTypes, bsDynamicFormFieldWrapperTypes, bsDynamicFormFileType, bsDynamicFormIconType, bsDynamicFormInputTypes, bsDynamicFormLibrary, bsDynamicFormModalType, bsDynamicFormNumberboxType, bsDynamicFormRadioType, bsDynamicFormSelectType, bsDynamicFormTabsType, bsDynamicFormTextareaType, bsDynamicFormTextboxType, bsDynamicFormsDefaultFeatures, provideBsDynamicForms, provideBsDynamicFormsWithDefaultFeatures, withBsDynamicFormActionDefaultFeatures, withBsDynamicFormElementDefaultFeatures, withBsDynamicFormFieldWrapperDefaultFeatures, withBsDynamicFormInputDefaultFeatures };
//# sourceMappingURL=dynamic-forms-bootstrap.mjs.map
